// diablo2_cheditDlg.h : header file
//

#if !defined(AFX_DIABLO2_CHEDITDLG_H__6C2AB227_5020_11D4_A778_00A0CC3A0C54__INCLUDED_)
#define AFX_DIABLO2_CHEDITDLG_H__6C2AB227_5020_11D4_A778_00A0CC3A0C54__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CDiablo2_cheditDlg dialog

/*
Diablo 2 character editor - by Lee Hamel (lee_hamel@hotmail.com)

This program has not been tested extensively.  Use at your own risk.
Make a backup copy of your SAVE directory before making any changes.  Source code is included for the hell of it.

*.D2S files

offset   8h, 15 bytes: name
offset    ?,  ? bytes: class
offset  24h,  2 bytes: level
offset 235h,  2 bytes: strength
offset 239h,  2 bytes: energy
offset 23dh,  2 bytes: dexterity
offset 241h,  2 bytes: vitality
offset 24ah,  2 bytes: life max
offset 24eh,  2 bytes: life current
offset 252h,  2 bytes: mana max
offset 256h,  2 bytes: mana current
offset 25ah,  2 bytes: stamina max
offset 25eh,  2 bytes: stamina current
offset 265h,  4 bytes: experience
offset 269h,  4 bytes: gold on person
offset 26dh,  4 bytes: gold in stash
offset 51ah,  2 bytes: attack rating
offset 751h,  1 byte : defense
*/

#define OFFSET_NAME				0x0008
#define OFFSET_CLASS			0x0000				// Don't know
#define OFFSET_LEVEL			0x24
#define OFFSET_STRENGTH			0x235
#define OFFSET_DEXTERITY		0x23d
#define OFFSET_VITALITY			0x241
#define OFFSET_ENERGY			0x239
#define OFFSET_LIFE_MAX			0x24a
#define OFFSET_LIFE_CURRENT		0x24e
#define OFFSET_MANA_MAX			0x252
#define OFFSET_MANA_CURRENT		0x256
#define OFFSET_STAMINA_MAX		0x25a
#define OFFSET_STAMINA_CURRENT	0x25e
#define OFFSET_EXPERIENCE		0x265
#define OFFSET_GOLD_PERSON		0x269
#define OFFSET_GOLD_STASH		0x26d
#define OFFSET_ATTACK_RATING	0x51a
#define OFFSET_DEFENSE			0x751

#define LENGTH_NAME				15
#define LENGTH_CLASS			0					// Don't know
#define LENGTH_LEVEL			2
#define LENGTH_STRENGTH			2
#define LENGTH_DEXTERITY		2
#define LENGTH_VITALITY			2
#define LENGTH_ENERGY			2
#define LENGTH_LIFE_MAX			2
#define LENGTH_LIFE_CURRENT		2
#define LENGTH_MANA_MAX			2
#define LENGTH_MANA_CURRENT		2
#define LENGTH_STAMINA_MAX		2
#define LENGTH_STAMINA_CURRENT	2
#define LENGTH_EXPERIENCE		4
#define LENGTH_GOLD_PERSON		4
#define LENGTH_GOLD_STASH		4
#define LENGTH_ATTACK_RATING	2
#define LENGTH_DEFENSE			1


class CDiablo2_cheditDlg : public CDialog
{
// Construction
public:
	CDiablo2_cheditDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CDiablo2_cheditDlg)
	enum { IDD = IDD_DIABLO2_CHEDIT_DIALOG };
	CString	m_filename;
	CString	m_name;
	CString	m_class;
	UINT	m_level;
	UINT	m_experience;
	UINT	m_strength;
	UINT	m_dexterity;
	UINT	m_vitality;
	UINT	m_energy;
	UINT	m_attackRating;
	UINT	m_defense;
	UINT	m_staminaCurrent;
	UINT	m_staminaMax;
	UINT	m_lifeCurrent;
	UINT	m_lifeMax;
	UINT	m_manaCurrent;
	UINT	m_manaMax;
	UINT	m_goldPerson;
	UINT	m_goldStash;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDiablo2_cheditDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON		m_hIcon;
	CFile		m_CFile;
	
	void		EnableControls();
	void		DisableControls();
	void		LoadData();
	void		SaveData();

	// Generated message map functions
	//{{AFX_MSG(CDiablo2_cheditDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnFileLoad();
	afx_msg void OnFileSave();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DIABLO2_CHEDITDLG_H__6C2AB227_5020_11D4_A778_00A0CC3A0C54__INCLUDED_)
